﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace XamDoughnutChart_Legend
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public List<Category> model { get; set; }

        public MainWindow()
        {
            model = new List<Category>()
                {
                    new Category{label = "parent1", value = 3, children = new List<Category>
                    { 
                        new Category { label="child1", value=2 }, 
                        new Category { label="child2", value=4 },
                        new Category { label="child3", value=8 },
                    }},
                    new Category{label = "parent2", value = 7, children = new List<Category>
                    { 
                        new Category { label="child4", value=2 }, 
                        new Category { label="child5", value=4 },
                        new Category { label="child6", value=8 },
                        new Category { label="child7", value=8 },
                    }},
                };

            InitializeComponent();
            this.DataContext = this;
        }

        private void ringSeries_Loaded(object sender, RoutedEventArgs e)
        {

        }
    }

    public class Category : INotifyPropertyChanged
    {
        private string _label;
        private double _value;
        

        public string label
        {
            get { return _label; }
            set
            {
                _label = value;
                OnPropertyChanged("label");
            }
        }
        public double value
        {
            get { return _value; }
            set
            {
                _value = value;
                OnPropertyChanged("value");
            }
        }

        public List<Category> children { get; set; }

        public event PropertyChangedEventHandler PropertyChanged;

        private void OnPropertyChanged(string strPropertyName)
        {
            if (PropertyChanged != null)
                PropertyChanged(this, new PropertyChangedEventArgs(strPropertyName));
        }
    }

}